#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// </summary>
    [Description("This Indicator was built to show the Wide Range Body and Hidden Gap as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type")]
    public class bcHiddenGapNativePnF : Indicator
    {
        #region Variables
        // Wizard generated variables
        //    private	SolidBrush[]		brushes				= { new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black) };
		
			private int	linewidth	= 2;	
			private int _intCalculationIndex = 1;
			private int _intStartBar = 0;
			private bool enableAlert= true;
			private string audioFile= "Alert3.wav";
			
			private Color WRBup=Color.DeepSkyBlue;
			private Color WRBdown=Color.DarkMagenta;
			private Color hiddenGapdown=Color.Magenta;
			private Color hiddenGapup=Color.Cyan;
			private int  opaque = 2;
			
			#endregion

        /// <summary>
       /// </summary>
        protected override void Initialize()
        {
			AutoScale					= false;
			Overlay						= true;
	     }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
			
        protected override void OnBarUpdate()			
       {	this._intCalculationIndex = CalculateOnBarClose ? 0 : 1;
			if (CurrentBar < 5)
				return;
			{						
			#region Up Candles	
			//Wide Range Body Up+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++Up++++++++++++++++++++
				if(Close[0]>Open[0]
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[1]-Open[1])   //Candle Body one back is WRB?
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[2]-Open[2])   //WRB > Interval 1st Prior
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[3]-Open[3]))//WRB > Interval 2nd Prior
				{BarColor= WRBup;
				DrawLine(CurrentBar.ToString(), false, 0, Low[0],0, High[0], WRBup, DashStyle.Solid, 10);
				}
				
			//Hidden Gap Up+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++Up+++++++++++++++++++
				if (Low[0] > High[2]  //Gap from Current Candle to Candle before WRB
				&& Math.Abs(Close[1]-Open[1])>Math.Abs(Close[2]-Open[2])   //Candle Body one back is WRB?
				&&Math.Abs(Close[1]-Open[1])>Math.Abs(Close[3]-Open[3])   //WRB > Interval 1st Prior
				&&Math.Abs(Close[1]-Open[1])>Math.Abs(Close[4]-Open[4]))   //WRB > Interval 2nd Prior
				{
				DrawRectangle(CurrentBar.ToString(), false, 2, High[2] , 0, Low[0], hiddenGapup, hiddenGapup, Opacity);		
				if (enableAlert)
				{
					Alert("Alert", NinjaTrader.Cbi.Priority.High, "Alert", AudioFile, 20, hiddenGapup, Color.Black);	
				}}
				#endregion
			#region Down Candles	
				//Wide Range Body Down---------------------------------------------------------------------Down--------------------------------------------
				if(Close[0]<Open[0]
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[1]-Open[1])   //Candle Body one back is WRB?
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[2]-Open[2])   //WRB > Interval 1st Prior
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[3]-Open[3]))//WRB > Interval 2nd Prior
				{BarColor= WRBdown;
				DrawLine(CurrentBar.ToString(), false, 0, Low[0],0, High[0], WRBdown, DashStyle.Solid, 10);}	
				
				//Hidden Gap Down ---------------------------------------------------------------------------Down--------------------------------------------
				if (High[0] < Low[2]   //Gap from Current Candle to Candle before WRB
				&& Math.Abs(Close[1]-Open[1])>Math.Abs(Close[2]-Open[2])  //Candle Body one back is WRB?
				&& Math.Abs(Close[1]-Open[1])>Math.Abs(Close[3]-Open[3])  //Candle Body one back is WRB? 
				&& Math.Abs(Close[1]-Open[1])>Math.Abs(Close[4]-Open[4])  //Candle Body one back is WRB?	
				)	
				{			
				DrawRectangle(CurrentBar.ToString(), false, 2, Low[2], 0, High[0] , hiddenGapdown,hiddenGapdown,Opacity);	
				if (enableAlert)
				{
					Alert("Alert", NinjaTrader.Cbi.Priority.High, "Alert",  AudioFile, 20, hiddenGapdown, Color.Black);		
				}}
			#endregion
			}
		}
		// In order to trim the indicator's label we need to override the ToString() method.
			public override string ToString()
				{
				return Name ;
		//		return "" ;	
				}
			
        #region Properties       
		#region Gap Down Color
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\tGap Down Color")]
		public Color GapDownColor
		{
     	get { return hiddenGapdown; }
    	set { hiddenGapdown = value; }
		}
		[Browsable(false)]
		public string GapDownColorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(hiddenGapdown); }
			set {hiddenGapdown = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		#endregion
		
		#region Gap Up Color
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\tGap Up Color")]
		public Color GapUpColor
		{
     	get { return hiddenGapup; }
    	set { hiddenGapup = value; }
		}
		[Browsable(false)]
		public string GapUpColorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(hiddenGapup); }
			set {hiddenGapup = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		#endregion
			
		#region Gap Fill Opacity
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\tOpacity Gap Fill")]
		public int Opacity
		{
     	get { return opaque; }
    	set { opaque = value; }
		}
		#endregion
		
		#region WRB Up Color
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\t WRB Up Color")]
		public Color WRBUpColor
		{
     	get { return WRBup; }
    	set { WRBup = value; }
		}
		[Browsable(false)]
		public string WRBUpColorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(WRBup); }
			set { WRBup = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		#endregion
		
		#region WRB Down Color
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\t WRB Down Color")]
		public Color WRBDownColor
		{
     	get { return WRBdown; }
    	set { WRBdown = value; }
		}
		[Browsable(false)]
		public string WRBDownColorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(WRBdown); }
			set { WRBdown = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		#endregion
		
		#region Sound Alert
		[Description("Alert On/Off")]
        [GridCategory("Parameters")]
        public bool EnableAlert
        {
           get { return enableAlert ; }
          set { enableAlert =  value; }
        }
			[Description("Alert Sound")]
        [GridCategory("Parameters")]
        public string AudioFile
        {
          get { return audioFile ; }
         set { audioFile =  value; }
        }
		#endregion
			
		#endregion
		
	}
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private bcHiddenGapNativePnF[] cachebcHiddenGapNativePnF = null;

        private static bcHiddenGapNativePnF checkbcHiddenGapNativePnF = new bcHiddenGapNativePnF();

        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Gap as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        public bcHiddenGapNativePnF bcHiddenGapNativePnF(string audioFile, bool enableAlert)
        {
            return bcHiddenGapNativePnF(Input, audioFile, enableAlert);
        }

        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Gap as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        public bcHiddenGapNativePnF bcHiddenGapNativePnF(Data.IDataSeries input, string audioFile, bool enableAlert)
        {
            if (cachebcHiddenGapNativePnF != null)
                for (int idx = 0; idx < cachebcHiddenGapNativePnF.Length; idx++)
                    if (cachebcHiddenGapNativePnF[idx].AudioFile == audioFile && cachebcHiddenGapNativePnF[idx].EnableAlert == enableAlert && cachebcHiddenGapNativePnF[idx].EqualsInput(input))
                        return cachebcHiddenGapNativePnF[idx];

            lock (checkbcHiddenGapNativePnF)
            {
                checkbcHiddenGapNativePnF.AudioFile = audioFile;
                audioFile = checkbcHiddenGapNativePnF.AudioFile;
                checkbcHiddenGapNativePnF.EnableAlert = enableAlert;
                enableAlert = checkbcHiddenGapNativePnF.EnableAlert;

                if (cachebcHiddenGapNativePnF != null)
                    for (int idx = 0; idx < cachebcHiddenGapNativePnF.Length; idx++)
                        if (cachebcHiddenGapNativePnF[idx].AudioFile == audioFile && cachebcHiddenGapNativePnF[idx].EnableAlert == enableAlert && cachebcHiddenGapNativePnF[idx].EqualsInput(input))
                            return cachebcHiddenGapNativePnF[idx];

                bcHiddenGapNativePnF indicator = new bcHiddenGapNativePnF();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AudioFile = audioFile;
                indicator.EnableAlert = enableAlert;
                Indicators.Add(indicator);
                indicator.SetUp();

                bcHiddenGapNativePnF[] tmp = new bcHiddenGapNativePnF[cachebcHiddenGapNativePnF == null ? 1 : cachebcHiddenGapNativePnF.Length + 1];
                if (cachebcHiddenGapNativePnF != null)
                    cachebcHiddenGapNativePnF.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachebcHiddenGapNativePnF = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Gap as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.bcHiddenGapNativePnF bcHiddenGapNativePnF(string audioFile, bool enableAlert)
        {
            return _indicator.bcHiddenGapNativePnF(Input, audioFile, enableAlert);
        }

        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Gap as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        public Indicator.bcHiddenGapNativePnF bcHiddenGapNativePnF(Data.IDataSeries input, string audioFile, bool enableAlert)
        {
            return _indicator.bcHiddenGapNativePnF(input, audioFile, enableAlert);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Gap as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.bcHiddenGapNativePnF bcHiddenGapNativePnF(string audioFile, bool enableAlert)
        {
            return _indicator.bcHiddenGapNativePnF(Input, audioFile, enableAlert);
        }

        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Gap as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        public Indicator.bcHiddenGapNativePnF bcHiddenGapNativePnF(Data.IDataSeries input, string audioFile, bool enableAlert)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.bcHiddenGapNativePnF(input, audioFile, enableAlert);
        }
    }
}
#endregion
